<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div class="search" v-show="showSearch">
        <el-form :model="queryParams" ref="queryFormRef" :inline="true" label-width="68px">
          <el-form-item label="站点" prop="siteId">
            <el-select v-model="queryParams.siteId" placeholder="请选择站点" clearable>
              <el-option v-for="item in sites" :key="item.id" :label="item.name" :value="item.id" />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd"
              v-hasPermi="['smarttrace:section:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()"
              v-hasPermi="['smarttrace:section:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()"
              v-hasPermi="['smarttrace:section:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport"
              v-hasPermi="['smarttrace:section:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="sectionList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="站点" align="center" prop="siteId">
          <template #default="{ row }">
            <span>{{ sites.find(item => item.id === row.siteId)?.name }}</span>
          </template>
        </el-table-column>
        <el-table-column label="标题" align="center" prop="title" />
        <el-table-column label="序号" align="center" prop="sort" />
        <el-table-column label="图标" align="center" prop="icon" />
        <el-table-column label="页面路径" align="center" prop="page" />
        <el-table-column label="页面参数" align="center" prop="param" >
          <template #default="{ row }">
            {{ JSON.stringify(row.param) }}
          </template>
        </el-table-column>
        <el-table-column label="级别" align="center" prop="level" />
        <el-table-column label="创建人" align="center" prop="createName" />
        <el-table-column label="创建时间" align="center" prop="createTime" width="180">
          <template #default="scope">
            <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                v-hasPermi="['smarttrace:section:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                v-hasPermi="['smarttrace:section:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改栏目对话框 -->
    <el-dialog :close-on-click-modal="false" :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="sectionFormRef" :model="form" :rules="rules" label-width="108px">
        <el-form-item label="站点" prop="siteId">
          <el-select v-model="form.siteId" placeholder="请选择站点" clearable @change="refreshSectionTree">
            <el-option v-for="item in sites" :key="item.id" :label="item.name" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="父级栏目" prop="pid">
          <el-tree-select v-model="form.pid" :data="sectionTree"  check-strictly
            :props="{ label: 'title', value: 'id', disabled: 'disabled' }" placeholder="请选择父级栏目" clearable />
        </el-form-item>
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入标题" />
        </el-form-item>
        <el-form-item label="序号" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入序号" />
        </el-form-item>
        <el-form-item label="图标" prop="icon">
          <el-input v-model="form.icon" placeholder="请输入图标" />
        </el-form-item>
        <el-form-item label="页面路径" prop="page">
          <el-input v-model="form.page" placeholder="请输入页面路径" />
        </el-form-item>
        <el-form-item label="页面参数" prop="param">
          <el-input v-model="form.param" placeholder="请输入页面参数" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Section" lang="ts">
import { listSection, getSection, delSection, addSection, updateSection } from '@/api/smarttrace/section';
import { SectionVO, SectionQuery, SectionForm } from '@/api/smarttrace/section/types';
import { getDeptSite } from '@/api/smarttrace/site/index';
import { handleTree } from '@/utils/ruoyi';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const sectionList = ref<SectionVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const sectionFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: SectionForm = {
  id: undefined,
  siteId: undefined,
  pid: undefined,
  title: undefined,
  sort: undefined,
  icon: undefined,
  page: undefined,
  param: undefined,
  level: undefined,
  partnerId: undefined,
}
const data = reactive<PageData<SectionForm, SectionQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    siteId: undefined,
    pid: undefined,
    title: undefined,
    sort: undefined,
    icon: undefined,
    page: undefined,
    param: undefined,
    level: undefined,
    partnerId: undefined,
  },
  rules: {
    id: [
      { required: true, message: "ID不能为空", trigger: "blur" }
    ],
    siteId: [
      { required: true, message: "站点ID不能为空", trigger: "blur" }
    ],
    pid: [
      { required: true, message: "上级id不能为空", trigger: "blur" }
    ],
    title: [
      { required: true, message: "标题不能为空", trigger: "blur" }
    ],
    sort: [
      { required: true, message: "序号不能为空", trigger: "blur" }
    ],
    icon: [
      { required: true, message: "图标不能为空", trigger: "blur" }
    ],
    page: [
      { required: true, message: "页面路径不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询栏目列表 */
const getList = async () => {
  loading.value = true;
  const res = await listSection(queryParams.value);
  sectionList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  sectionFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: SectionVO[]) => {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  refreshSectionTree();
  dialog.visible = true;
  dialog.title = "添加栏目";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: SectionVO) => {
  reset();
  const _id = row?.id || ids.value[0]
  const res = await getSection(_id);
  Object.assign(form.value, res.data);
  form.value.param = JSON.stringify(form.value.param);
  await refreshSectionTree();
  dialog.visible = true;
  dialog.title = "修改栏目";
}

/** 提交按钮 */
const submitForm = () => {
  sectionFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateSection(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addSection(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("修改成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: SectionVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除栏目编号为"' + _ids + '"的数据项？').finally(() => loading.value = false);
  await delSection(_ids);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('smarttrace/section/export', {
    ...queryParams.value
  }, `section_${new Date().getTime()}.xlsx`)
}
const sites = ref<any[]>([]);
const initSites = async () => {
  const res = await getDeptSite();
  sites.value = res.data;
}
const sectionTree = ref<any[]>([]);
const refreshSectionTree = async () => {
  if (!form.value.siteId) {
    sectionTree.value = [{ id: 0, title: '根目录', pid: -1 }];
    form.value.pid = undefined;
    return;
  }
  const res = await listSection({ siteId: form.value.siteId, pageNum: 1, pageSize: 1000 });
  res.rows.forEach(item => {
    if (item.id == form.value.id || item.level > (form.value.level || 999)) {
      item.disabled = true;
    }
  });
  sectionTree.value = handleTree([...res.rows, { id: 0, title: '根目录', pid: -1, disabled: false }], 'id', 'pid', 'children');
}
onMounted(() => {
  getList();
  initSites();
});
</script>
